#include "BillExp.h"

#include "setup.h"


Texture *T[16];


//constructor
BillboardExplosions::BillboardExplosions(GLfloat x,GLfloat y,GLfloat z)
{
	init = 0;
	SetPosition(x,y,z);
	numTex = 0;
	Doba = 0;
}

//constructor
BillboardExplosions::BillboardExplosions(GLfloat* p)
{
	init = 0;
	SetPosition(p[0], p[1], p[2]);
	numTex = 0;
	Doba = 0;
}

// funkce pro vypocet zmeny textury
void BillboardExplosions::TimeTick(const float DTime)
  {
#ifdef USEMOD_BILLEXP
  Doba +=DTime;
  if (Doba >= 0.1)
	{
	Doba = 0;
	if (numTex == 15) numTex = 0;
	else numTex++;
	}
#endif
  }

// inicializacion function of billboard
void BillboardExplosions::Init(void)
{
  int i;

   init = 1;
   bdisp = glGenLists(1);
   glNewList(bdisp,GL_COMPILE);
   glBegin(GL_QUADS);
//  glGetFloatv(GL_CURRENT_COLOR,col);
	  glNormal3f(0.0,0.0,1.0);
	  glNormal3f(0.0,0.0,1.0);
	  glTexCoord2f(0.0,0.0);
	  glVertex3f(-10,-10,0);
	  glTexCoord2f(1.0,0.0);
	  glVertex3f(10,-10,0);
	  glTexCoord2f(1.0,1.0);
	  glVertex3f(10,10,0);
	  glTexCoord2f(0.0,1.0);
	  glVertex3f(-10,10,0);
  //    glColor4fv(col);
   glEnd();
   glEndList();
   for (i=0;i<16;i++)
	   proctexture[i] = T[i]->TexName();

}

// billboard painting
void BillboardExplosions::Render(void)
{
#ifdef USEMOD_BILLEXP
   if (!init) Init();
//   glPushMatrix();
//   glColor3f(1.0,0.0,0.0);
/*   glTranslatef(-ViewersMatrices.ViewerPos[0]+position[0],-ViewersMatrices.ViewerPos[1]+position[1],-ViewersMatrices.ViewerPos[2]+position[2]);
   glMultMatrixf(&ViewersMatrices.TransposedRotMatrix[0][0]);
   glTranslatef(ViewersMatrices.ViewerPos[0],ViewersMatrices.ViewerPos[1],ViewersMatrices.ViewerPos[2]);*/

   //naneseni textur
   glEnable(GL_TEXTURE_2D);
   glBindTexture(GL_TEXTURE_2D, proctexture[numTex]);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	BillboardRender(GetPosX(), GetPosY(), GetPosZ(), 10);
	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
//   glCallList(bdisp);
//   glPopMatrix();
#endif
}

// nacteni textur
void Textures(void)
{
#ifdef USEMOD_BILLEXP
  int i;
  for (i=0;i<=15;i++)
	{
	T[i] = new Texture;
	switch (i)
	  {
	  case 0:T[i]->LoadTGA("scene\\exp01.TGA");
				break;
	  case 1:T[i]->LoadTGA("scene\\exp02.TGA");
				break;
	  case 2:T[i]->LoadTGA("scene\\exp03.TGA");
				break;
	  case 3:T[i]->LoadTGA("scene\\exp04.TGA");
				break;
	  case 4:T[i]->LoadTGA("scene\\exp05.TGA");
				break;
	  case 5:T[i]->LoadTGA("scene\\exp06.TGA");
				break;
	  case 6:T[i]->LoadTGA("scene\\exp07.TGA");
				break;
	  case 7:T[i]->LoadTGA("scene\\exp08.TGA");
				break;
	  case 8:T[i]->LoadTGA("scene\\exp09.TGA");
				break;
	  case 9:T[i]->LoadTGA("scene\\exp10.TGA");
				break;
	  case 10:T[i]->LoadTGA("scene\\exp11.TGA");
				break;
	  case 11:T[i]->LoadTGA("scene\\exp12.TGA");
				break;
	  case 12:T[i]->LoadTGA("scene\\exp13.TGA");
				break;
	  case 13:T[i]->LoadTGA("scene\\exp14.TGA");
				break;
	  case 14:T[i]->LoadTGA("scene\\exp15.TGA");
				break;
	  case 15:T[i]->LoadTGA("scene\\exp16.TGA");
				break;
	  } // switch
	} // for
#endif
} // Textures



