/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _Fonts_h_
#define _Fonts_h_

#include <stdio.h>
#include "mygl.h"
#include "fontcmn.h"


class BitmapFont {
private:
	int width;
	int height;
	unsigned int lists;
public:
	inline int Width()  { return width; }
	inline int Height()  { return height; }
	inline unsigned int Lists()  { return lists; }
	void Init(BitmapFontData *Data);
	void Done();

	BitmapFont()  : lists(0) {}
	BitmapFont(BitmapFontData *Data)  : lists(0) { Init(Data); }
	~BitmapFont()  { Done(); }

	void DrawString(char *S, GLubyte *Color,
			const GLfloat X, const GLfloat Y,	const GLfloat Z = 0.0);
};


extern BitmapFont *font_Fotinos19;


int FontsInit(void);
void FontsDone(void);


#endif /* ifdef _Fonts_h_ */




