/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _InputDevices_h_
#define _InputDevices_h_


#include "setup.h"


#ifdef USE_SDL
#include <SDL/SDL_mouse.h>
#include <SDL/SDL_keysym.h>
#endif


int MouseInit(void);
void MouseDone(void);
int MouseAcquire(void);
void MouseUnacquire(void);
int MouseGetData(int &X, int &Y);
// MouseWindowCallback - for internal use; Must be called after window resize
// and window move
int MouseWindowCallback(void);



typedef struct {
	bool Down;
	bool Pressed;
	int Mod;
} KeyboardKeyInfo;
#define KEYBOARD_KEY_MAX SDLK_LAST
extern KeyboardKeyInfo KeyboardKeyState[KEYBOARD_KEY_MAX];


int KeyboardInit(void);
void KeyboardDone(void);
int KeyboardAcquire(void);
void KeyboardUnacquire(void);
int KeyboardUpdate(void);


void KeyboardKeyDownCallback(const int Ch, const int Mod);
void KeyboardKeyUpCallback(const int Ch);
void KeyboardClearPressed();

#endif /* _Input_h_ */

