/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#ifndef _Scene_h_
#define _Scene_h_


#include "SceneClasses.h"
#include "dlist.h"

extern char ScenePath[];


// StaticList - double-linked list of static scene objects
extern XList<scStatic> StaticList;
// MobileList - double-linked list of mobile scene objects
extern XList<scMobile> MobileList;


int SceneInit(void);
void SceneDone(void);

void SceneRender(void);
void SceneTimeTick(const float DTime);
void SceneClear(void);
int SceneLoadDefault(void);

// functions for pausing game
enum FreezeMode { fsPaused, fsRunning, fsStarting };
FreezeMode SceneFreezeStatus(void);
void SceneFreeze(bool F);


#endif /* _Scene_h_ */
