/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#ifndef _Timers_h_
#define _Timers_h_



#ifdef WINDOZE
	// need 64bit integer
	#ifdef BORLANDLIB
	// Borland uses this
	typedef __int64 timType;
	#else
		#ifdef VISUAL_CPP
		// Visual Studio 64bit integer type
		typedef __int64 timType;
		#else
		// Mingw libraries has this
		typedef long long int timType;
		#endif
	#endif
#else
typedef long timType;
#endif


extern double timTickTime;
extern timType frLastFrameTicks;
extern double frLastFrameTime;


int timInit(void);


timType timGetTicks(void);
inline timType timGetTicksFrom(const timType Ticks)  { return timGetTicks() - Ticks; };
inline double timTicksToSec(const timType Ticks)  { return (Ticks) * timTickTime; };

double timGetRT(void);
inline double timGetRTFrom(const double Time)  { return timGetRT() - Time; };



int frInit(void);
void frReset(void);
void frNextFrame(void);
float frGetAvgFrameRate(void);
float frGetPeakFrameRate(void);
float frGetWorstFrameRate(void);
bool frIsFrameRateUpdated(void);
bool frIsFrameRateValid(void);


#endif /* _Timers_h_ */
