/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#include <assert.h>

#include "config.h"


#ifdef NEED_PI
// Visual C++
float M_PI = 3.141592535f;
#endif


#ifdef NEED_RANDOM
// Visual C++
#include <stdlib.h>
int random(int Max)
{
	return int((float(rand()) / RAND_MAX) * Max);
};
#endif


/* ##################################################
   # sincos
*/
#ifndef HAVE_SINCOS
#include <math.h>
void sincos(double x, double *outs, double *outc)
{
  *outs = sin(x);
  *outc = cos(x);
}
#endif /* HAVE_SINCOS */


/* ##################################################
   # strlwr
*/

#ifndef HAVE_STRLWR
char* strlwr(char *s)
{
	char *temp = s;
	while (*s) {
		if (*s >= 'A' && *s <= 'Z') *s += 'a'-'A';
		s++;
	}
	return temp;
}
#endif


/* ##################################################
   # sincos
*/
#ifndef HAVE_NEW

#ifdef VISUAL_CPP
#define WANT_NEW
#include "porting.h"

nothrow_t nothrow;
#endif

#endif /* HAVE_NEW */


#ifdef BORLANDLIB
#include <system.hpp>
Word Saved8087CW = 0;
void Disable8087Exceptions(void)
{
	assert(Saved8087CW == 0);

	Saved8087CW = Default8087CW;
	Set8087CW(0x133f);
}
void Enable8087Exceptions(void)
{
	assert(Saved8087CW != 0);

	Set8087CW(Saved8087CW);
	Saved8087CW = 0;
}
#endif

/*#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef HAVE_STRDUP
#include <stdlib.h>
char *strdup(const char *s)
{
  int l;
  char *buf;

  if (!s) return NULL;

  l = strlen(s) + 1;

  buf = (char *)malloc(l*sizeof(char));
  memcpy(buf, s, l);

  return buf;
}
*/

void convertFilename(char *s)
{
  while (*s) {
    switch (*s) {
#    ifdef WINDOZE
      case '/' : *s = '\\'; break;
#    endif
#    ifdef UNIX
      case '\\' : *s = '/'; break;
#    endif
      default : break;
    };
    s++;
  }
}
