/*
 * The POG project
 * Copyright 2001 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TEMPSUFFIX ".undos.temp"
int main(int argc, char *argv[])
{
  FILE *fr;
  FILE *fw;
  char *tempname;
  int i,c;
  struct stat s;

  for (i = 1; i < argc; i++) {
    if (stat(argv[i], &s)) {
      perror("stat");
      exit(EXIT_FAILURE);
    }
    if (S_ISREG(s.st_mode)) {
      if ((fr = fopen(argv[i], "rt")) == NULL) {
        perror(argv[i]);
        exit(EXIT_FAILURE);
      }
      tempname = (char*)malloc(strlen(argv[i]) + strlen(TEMPSUFFIX) + 1);
      strcpy(tempname, argv[i]);
      strcat(tempname, TEMPSUFFIX);
      
      if ((fw = fopen(tempname, "wt")) == NULL) {
        perror(tempname);
        exit(EXIT_FAILURE);
      }
      
      while ((c = getc(fr)) != EOF) if (c != '\r') putc(c, fw);
      
      fclose(fw);
      fclose(fr);
      if (rename(tempname, argv[i])) {
        perror("rename");
        exit(EXIT_FAILURE);
      }
      free(tempname);
    }
  }
  return EXIT_SUCCESS;
}
